<?php include ("../acceso/seguridad.php");	//verifica que el usuario está correctamente identificado?>

<!DOCTYPE HTML>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title>Estadísticas</title>
   	<link rel="stylesheet" type="text/css" href="../css/style.css">
   	<link rel="stylesheet" type="text/css" href="../css/menu.css">
    <link rel="stylesheet" type="text/css" href="../css/estiloTabla.css">
   	<link rel="icon" type="image/png" href="../img/logo_raspy.png">
        
  	<?php include ("../controladores/controladorAccesoBD.php");	//nos conectamos a la Base de Datos?>
	
    <!--incluimos jQuery y el script necesario para representar la gráfica-->
	<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js"></script>
	<style type="text/css">
		${demo.css}
	</style>
	<script type="text/javascript">
		$(function () {
    		$('#container').highcharts({
       			chart: {
           			zoomType: 'xy'
       			},
       			title: {
           			text: 'TEMPERATURA Y HUMEDAD'
       			},
       			subtitle: {
           			text: 'Fuente: sensor DHT11'
       			},
       			xAxis: [{
           			categories: [
						<?php
							//creamos dos variables que contienen la fecha y hora de inicio y la fecha y hora de final
							$momentoInicio = $_POST["fecha1"] .' ' .$_POST["hora1"];
							$momentoFinal = $_POST["fecha2"] .' ' .$_POST["hora2"];
							//seleccionamos y escribimos todos registros de temperatura comprendidos entre los dos momentos
							$sql = "SELECT * FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
							$result = mysql_query($sql);
							while ($registros = mysql_fetch_array($result)){
								echo "'$registros[fecha]', ";
							}
						?>
					],
           			crosshair: true
       			}],
       			yAxis: [{ // Primary yAxis
           			labels: {
               			format: '{value}°C',
               			style: {
                   			color: Highcharts.getOptions().colors[1]
               			}
           			},
           			title: {
               			text: '<?php if (isset($_POST['checkboxTemperatura'])){echo "Temperatura (ºC)";}  ?>',
               			style: {
                   			color: Highcharts.getOptions().colors[1]
               			}
           			}
       			}, { // Secondary yAxis
           			title: {
               			text: '<?php if (isset($_POST['checkboxHumedad'])){echo "Humedad (%)";}  ?>',
               			style: {
                   			color: Highcharts.getOptions().colors[0]
               			}
           			},
           			labels: {
               			format: '{value} %',
               			style: {
                   			color: Highcharts.getOptions().colors[0]
               			}
           			},
           			opposite: true
       			}],
       			tooltip: {
           			shared: true
       			},
       			legend: {
           			layout: 'vertical',
           			align: 'left',
           			x: 80,
           			verticalAlign: 'top',
           			y: 60,
           			floating: true,
           			backgroundColor: (Highcharts.theme && Highcharts.theme.legendBackgroundColor) || 'transparent'
       			},		
       			series: [{
           			name: 'Humedad',
           			type: 'spline',
           			yAxis: 1,
           			data: [
						<?php
							//seleccionamos todos los registros de temperatura y humedad comprendidos entre los dos momentos y escribimos los de humedad		
							$sql = "SELECT * FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";  
							$result = mysql_query($sql);
							if (isset($_POST['checkboxHumedad'])){ 
								while ($registros = mysql_fetch_array($result)){ 
					 				echo "$registros[humedad],";
								}
							}
						?>
					],
           			tooltip: {
               			valueSuffix: ' %'
           			}
       			}, {
           			name: 'Temperatura',
           		type: 'spline',
           			data: [
						<?php
							//escribimos todos los registros de temperatura comprendidos entre los dos momentos	 
							$result2 = mysql_query($sql);		 				
							if (isset($_POST['checkboxTemperatura'])){ 
								while ($registros2 = mysql_fetch_array($result2)){ 
						 			echo "$registros2[temperatura],";
								}
							}
						?>
					],
           			tooltip: {
               			valueSuffix: '°C'
           			}
       			}]
    		});
		});
	</script>
</head>
    
<body>
   	<header> 
	      <img src="../img/logo_raspy.png" width="115" height="115" class="imgCabecera" align="absmiddle">
          <span class="tituloCabecera">Sistema de seguridad y monitorización basado en Raspberry Pi</span>
    </header>

   
    <div id="menu">
		<ul>
  			<li class="nivel1"><a href="./inicio.php" class="nivel1">Inicio</a></li>
  			<li class="nivel1"><a href="./camara.php" class="nivel1">Cámara</a>
           	 	<ul>
                    <li><a href="./galeria.php">Galería</a></li>
				</ul>
           	</li>
  			<li class="nivel1"><a href="./informes.php" class="nivel1">Informes</a>
				<ul>
                    <li><a href="./contenedorPDF.php">Informes Guardados</a></li>
				</ul>
			</li>
  			<li class="nivel1"><a href="./alertas.php" class="nivel1">Alertas</a></li>
  			<li class="nivel1"><a href="./control.php" class="nivel1">Control</a></li>
            <li class="cerrar"><a href="./salir.php" class="nivel1">Cerrar Sesión</a></li>
		</ul>
	</div>
    
    
    <section id="seccion0" style="background-color:#FFF">
    	<section class="estadisticasGrafica">
           	<br/>
			<script src="https://code.highcharts.com/highcharts.js"></script>			<!--gráfica-->
            <script src="https://code.highcharts.com/modules/exporting.js"></script>	<!--opciones para exportar la gráfica-->
            <div id="container" style="min-width: 310px; height: 400px; margin: 0 auto"></div>
          	<br/>
       	</section>
            
    	<section class="estadisticasDatos">
			<table class="table1" align="center">
	            <thead>
                  	<tr>
                     	<th></th>
                        <th scope="col">Valor Máximo</th>
                        <th scope="col">Valor Mínimo</th>
                        <th scope="col">Media</th>
                        <th scope="col">Desviación Estándar</th>
                        <th scope="col">Coeficiente de Variación</th>
                  	</tr>
               	</thead>
				<tbody>
                	<tr>
                		<th scope="row">Temperatura</th>
                        <td>
                            <?php //en caso de haberse seleccionado el checkbox de Tª se imprime el valor máximo de la muestra
								if (isset($_POST['checkboxTemperatura'])){ 
									$sql = "SELECT MAX(temperatura) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoTmax = mysql_query($sql);
									echo mysql_result($resultadoTmax,0) .'ºC';
								} else{ 
                               		echo '-';
							}?>
                      	</td>
                        <td>
                            <?php //en caso de haberse seleccionado el checkbox de Tª se imprime el valor mínimo de la muestra
								if (isset($_POST['checkboxTemperatura'])){ 
									$sql = "SELECT MIN(temperatura) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoTmin = mysql_query($sql);
									echo mysql_result($resultadoTmin,0) .'ºC';
							 	} else{ 
                                	echo '-';
							}?>    
                     	</td>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de Tª se imprime la media de la muestra
								if (isset($_POST['checkboxTemperatura'])){ 
									$sql = "SELECT AVG(temperatura) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoTmedia = mysql_query($sql);
									echo round(mysql_result($resultadoTmedia,0),2) .'ºC';
								} else{ 
                               		echo '-';
							}?>
                    	</td>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de Tª se imprime la desviación de la muestra
								if (isset($_POST['checkboxTemperatura'])){ 
									$sql = "SELECT STDDEV(temperatura) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoTdesviacion = mysql_query($sql);
									echo round(mysql_result($resultadoTdesviacion,0),2) .'ºC';
							} else{ 
                               		echo '-';
							}?>
                        </td>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de Tª se imprime el coeficiente de variación
								if (isset($_POST['checkboxTemperatura'])){ 
									$resultadoTcv = round(mysql_result($resultadoTdesviacion,0),2) / round(mysql_result($resultadoTmedia,0),2);
									echo round($resultadoTcv,2);
							} else{ 
                               		echo '-';
							}?>
                        </td>
                  	</tr>
                    <tr>
                   		<th scope="row">Humedad</th>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de humedad se imprime el valor máximo de la muestra
								if (isset($_POST['checkboxHumedad'])){ 
									$sql = "SELECT MAX(humedad) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoHmax = mysql_query($sql);
									echo mysql_result($resultadoHmax,0) .'%';
								} else{ 
                               		echo '-';
							}?>
                     	</td>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de humedad se imprime el valor mínimo de la muestra
								if (isset($_POST['checkboxHumedad'])){ 
									$sql = "SELECT MIN(humedad) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoHmin = mysql_query($sql);
									echo mysql_result($resultadoHmin,0) .'%';
								} else{ 
                               		echo '-';
							}?>
                      	</td>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de humedad se imprime la media de la muestra
								if (isset($_POST['checkboxHumedad'])){ 
									$sql = "SELECT AVG(humedad) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoHmedia = mysql_query($sql);
									echo round(mysql_result($resultadoHmedia,0),2) .'%';
								} else{ 
                               		echo '-';
							}?>
                       	</td>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de humedad se imprime la desviación de la muestra
								if (isset($_POST['checkboxHumedad'])){ 
									$sql = "SELECT STDDEV(humedad) FROM sensor_temperatura WHERE fecha BETWEEN '$momentoInicio' AND '$momentoFinal'";
									$resultadoHdesviacion = mysql_query($sql);
									echo round(mysql_result($resultadoHdesviacion,0),2) .'%';
								} else{ 
                               		echo '-';
							}?>
                       	</td>
                        <td>
                           	<?php //en caso de haberse seleccionado el checkbox de humedad se imprime el coeficiente de variación
								if (isset($_POST['checkboxHumedad'])){ 
									$resultadoHcv = round(mysql_result($resultadoHdesviacion,0),2) / round(mysql_result($resultadoHmedia,0),2);
									echo round($resultadoHcv,2);
							} else{ 
                               		echo '-';
							}?>
                        </td>
                	</tr>
				</tbody>
			</table> 
			<br/>
           	<?php
				//creo variables de sesion que serán usadas en guardarEstadisticas.php
				$_SESSION['compruebaT'] = $_POST['checkboxTemperatura'];
				$_SESSION['compruebaH'] = $_POST['checkboxHumedad'];
				$_SESSION['Tmax'] = mysql_result($resultadoTmax,0);
				$_SESSION['Tmin'] = mysql_result($resultadoTmin,0);
				$_SESSION['Tmed'] = round(mysql_result($resultadoTmedia,0),2);
				$_SESSION['Tdesviacion'] = round(mysql_result($resultadoTdesviacion,0),2);
				$_SESSION['Tcv'] = round($resultadoTcv,2);
				$_SESSION['Hmax'] = mysql_result($resultadoHmax,0);
				$_SESSION['Hmin'] = mysql_result($resultadoHmin,0);
				$_SESSION['Hmed'] = round(mysql_result($resultadoHmedia,0),2);
				$_SESSION['Hdesviacion'] = round(mysql_result($resultadoHdesviacion,0),2);
				$_SESSION['Hcv'] = round($resultadoHcv,2);
				$_SESSION['Inicio'] = $momentoInicio;
				$_SESSION['Fin'] = $momentoFinal;
			?>
          	<br/>
            <a href="./guardarEstadisticas.php" style="text-decoration:none"><img border="0" src="../img/savepdf.png"></a>
            <br/><br/>
       	</section>
		<?php mysql_close($bdconex);  //nos desconectamos de la base de datos?>
   	</section>
        
            
	<footer>
     	<table id="pie" align="center" width="100%">
        	<tr>
            	<td id="pie_izquierda">
                	<b>Autor:</b> Javier García Prieto
            		<br/>
            		<b>Contacto:</b> <a href="mailto:javier.garcia.prieto@alumnos.uva.es" style="text-decoration:none; color:#FFF">javier.garcia.prieto@alumnos.uva.es
                </td>
                <td id="pie_derecha">
                	<b>Trabajo de Fin de Grado:</b>
            		<br/>
            		"Sistema de seguridad y monitorización basado en Raspberry Pi"
                </td>
            </tr>
            <tr>
                <td id="pie_centro" colspan="2">
               		Universidad de Valladolid
        			<br/>
        			Copyright © tfgjgp.ddns.net 2017
            	</td>
        	</tr>
    	</table>
	</footer> 
</body>
</html>
