<?php
	if (!isset($_GET['file']) || empty($_GET['file'])) {
 		exit();
	}
	$root = $_GET['root'];	//carpeta donde se encuentran los archivos a descargar, por ejemplo: "/home/pi/contenedorPDF/";
	$file = basename($_GET['file']);  //hacemos que se devuelva únicamente el nombre del archivo, eliminando cualquier ruta para que no se puedan descargar archivos de otras carpetas
	$path = $root.$file;
	$type = '';
	if (is_file($path)) {	//si la ruta es válida
 		$size = filesize($path);
 		if (function_exists('mime_content_type')) {
 			$type = mime_content_type($path);
 		} else if (function_exists('finfo_file')) {
 				$info = finfo_open(FILEINFO_MIME);
 				$type = finfo_file($info, $path);
 				finfo_close($info);
 			}
 			if ($type == '') {
 				$type = "application/force-download";
 			}
			// definir headers
 			header("Content-Type: $type");
 			header("Content-Disposition: attachment; filename=$file");
 			header("Content-Transfer-Encoding: binary");
 			header("Content-Length: " . $size);
 			// descargar archivo
 			readfile($path);
	} else {	//si la ruta no es válida
 		die("El archivo no existe.");
	}
?>