<?php include ("../acceso/seguridad.php");	//verifica que el usuario está correctamente identificado?>

<!DOCTYPE html>
<html lang="es">
<head>
     <meta charset="utf-8"/>
     <title>Galería</title>
     <link rel="stylesheet" type="text/css" href="../css/style.css">
     <link rel="stylesheet" type="text/css" href="../css/menu.css">
     <link rel="stylesheet" type="text/css" href="../css/estiloGaleria.css">
     <link rel="icon" type="image/png" href="../img/logo_raspy.png">  
</head>

<body>
	<header> 
    	<img src="../img/logo_raspy.png" width="115" height="115" class="imgCabecera" align="absmiddle">
        <span class="tituloCabecera">Sistema de seguridad y monitorización basado en Raspberry Pi</span>
    </header>    
    
    
    <div id="menu">
		<ul>
  			<li class="nivel1"><a href="./inicio.php" class="nivel1">Inicio</a></li>
  			<li class="nivel1"><a href="./camara.php" class="nivel1">Cámara</a>
           	 	<ul>
                    <li><a href="./galeria.php">Galería</a></li>
				</ul>
           	</li>
  			<li class="nivel1"><a href="./informes.php" class="nivel1">Informes</a>
				<ul>
                    <li><a href="./contenedorPDF.php">Informes Guardados</a></li>
				</ul>
			</li>
  			<li class="nivel1"><a href="./alertas.php" class="nivel1">Alertas</a></li>
  			<li class="nivel1"><a href="./control.php" class="nivel1">Control</a></li>
            <li class="cerrar"><a href="./salir.php" class="nivel1">Cerrar Sesión</a></li>
		</ul>
	</div>
    
    
   	<section id="seccion0"> 
    	<h1 class="titulo_seccion">Galería de imágenes</h1>
    	<br>
		<div id="principal">
        	<ul>
        		<?php
					//$directorio contiene el lugar donde se almacenan las imágenes (será usado por el controlador)
					$directorio = '/var/www/html/img/imagenesCapturadas/';
					include ("../controladores/controladorElementosOrdenados.php"); //controlador que muestra las imágenes ordenadas y aptas para descargar
				?>
        	</ul>
   		</div>
		<div style="clear: both"></div> <!--Elemento invisible después de todos los elementos posicionados de forma flotante para forzar a que el elemento contenedor tenga la altura suficiente y no descoloque los demás elementos-->
		<br>
        
        <h1 class="titulo_seccion">Galería de vídeos</h1>
    	<br>
		<div id="principal">
        	<ul>
				<?php
					//$directorio contiene el lugar donde se almacenan los vídeos (será usado por el controlador)             
                    $directorio = '/home/pi/piCamera/videosGrabados/';
                    include ("../controladores/controladorElementosOrdenados.php"); //controlador que muestra los vídeos ordenados y aptos para descargar   
                ?>
        	</ul>
		</div>
		<div style="clear: both"></div> <!--Elemento invisible después de todos los elementos posicionados de forma flotante para forzar a que el elemento contenedor tenga la altura suficiente y no descoloque los demás elementos-->
		<br>
    </section>
    
    
	<footer>
    	<table id="pie" align="center" width="100%">
        	<tr>
            	<td id="pie_izquierda">
                	<b>Autor:</b> Javier García Prieto
            		<br/>
            		<b>Contacto:</b> <a href="mailto:javier.garcia.prieto@alumnos.uva.es" style="text-decoration:none; color:#FFF">javier.garcia.prieto@alumnos.uva.es
                </td>
                <td id="pie_derecha">
                	<b>Trabajo de Fin de Grado:</b>
            		<br/>
            		"Sistema de seguridad y monitorización basado en Raspberry Pi"
                </td>
            </tr>
            <tr>
                <td id="pie_centro" colspan="2">
               		Universidad de Valladolid
        			<br/>
        			Copyright © tfgjgp.ddns.net 2017
                </td>
            </tr>
        </table>
  	</footer> 
</body>
</html>