<?php include ("../acceso/seguridad.php");	//verifica que el usuario está correctamente identificado?>

<!DOCTYPE html>
<html lang="es">
<head>
     <meta charset="utf-8"/>
     <title>Informes</title>
     <link rel="stylesheet" type="text/css" href="../css/style.css">
     <link rel="stylesheet" type="text/css" href="../css/menu.css">
     <link rel="stylesheet" type="text/css" href="../css/estiloTabla.css">
     <link rel="stylesheet" type="text/css" href="../css/estiloCheckbox.css">
     <link rel="icon" type="image/png" href="../img/logo_raspy.png">
    
    <?php include ("../controladores/controladorAccesoBD.php");	//nos conectamos a la Base de Datos?>
</head>

<body>
	<header> 
    	<img src="../img/logo_raspy.png" width="115" height="115" class="imgCabecera" align="absmiddle">
        <span class="tituloCabecera">Sistema de seguridad y monitorización basado en Raspberry Pi</span>
    </header>    
    
    
    <div id="menu">
		<ul>
  			<li class="nivel1"><a href="./inicio.php" class="nivel1">Inicio</a></li>
  			<li class="nivel1"><a href="./camara.php" class="nivel1">Cámara</a>
           	 	<ul>
                    <li><a href="./galeria.php">Galería</a></li>
				</ul>
           	</li>
  			<li class="nivel1"><a href="./informes.php" class="nivel1">Informes</a>
				<ul>
                    <li><a href="./contenedorPDF.php">Informes Guardados</a></li>
				</ul>
			</li>
  			<li class="nivel1"><a href="./alertas.php" class="nivel1">Alertas</a></li>
  			<li class="nivel1"><a href="./control.php" class="nivel1">Control</a></li>
            <li class="cerrar"><a href="./salir.php" class="nivel1">Cerrar Sesión</a></li>
		</ul>
	</div>
    
    
   	<section id="seccion0">
    	<!--apartado de creación de informes instantáneos configurados por el usuario-->
     	<section>            
           	<div align="center">  
      			<fieldset class="fieldsetAlertas">
					<legend style="text-align:center"> <h1 class="titulo_seccion">Informes Temperatura/humedad</h1></legend>
					<br/><br/> 
                    <form action="./estadisticas.php" name="formulario" method="post">
            		<?php
						//Se calcula la fecha actual para que sea la fecha máxima seleccionable
						$fechaActual = date('Y-m-d');
					?>
                    	<div id="checkTyH" style="float:right; margin-top:40px; margin-right:100px">
                        	<input id="one" type="checkbox" name="checkboxTemperatura" value="Temperatura" />
  							<label for="one">
                                <span></span>
                                Temperatura
                                <ins><i>Temperatura</i></ins>
                        	</label>
                            <input id="two" type="checkbox" name="checkboxHumedad" value="Humedad" />
  							<label for="two">
                                <span></span>
                                Humedad
                                <ins><i>Humedad</i></ins>
                        	</label>

                    		<!--<input type="checkbox" name="checkboxTemperatura" value="Temperatura"> Temperatura<br/>
                        	<input type="checkbox" name="checkboxHumedad" value="Humedad"> Humedad<br/><br/>-->
                        </div>
                    	<table class="table1" align="center">
                          <tr>
                            <!-- campo de entrada de fecha  (válida entre el 1 de enero de 2016 hasta la fecha actual-->
                            <th scope="row">Fecha de Inicio:</th>
                            <td><input type="date" name="fecha1" min="2016-01-01" max="<?php echo $fechaActual; ?>"></td>
                          </tr>
                          <tr>
                            <!-- campo de entrada de hora -->
                            <th scope="row">Hora de Inicio:</th>
                            <td><input type="time" name="hora1"></td>
                          </tr>
                          <tr>
                            <th scope="row">Fecha Final:</th>
                            <td><input type="date" name="fecha2" min="2016-01-01" max="<?php echo $fechaActual; ?>"></td>
                          </tr>
                          <tr>
                            <th scope="row">Hora Final:</th>
                            <td><input type="time" name="hora2"></td>
                          </tr>
                          <tr>
                          	<td colspan="2" align="center" style="background-color:transparent; border-color:transparent"><input class="boton-style" type="submit" name="generarGrafica" value="Generar Gráfica"/></td>
                          </tr>
                        </table>        
					</form> 
				</fieldset>
         	</div> 
            <br/>
        </section>
        
        <!--apartado de automatización de informes periódicos-->
        <section>            
           	<div align="center">
      			<fieldset class="fieldsetAlertas">
                  <legend style="text-align:center"> <h1 class="titulo_seccion">Informes periódicos</h1></legend>
         			<form method="post">
                    	<div id="checkTyH">
                    		<?php include ("../controladores/controladorInformesPeriodicos.php");//automatiza la generación de informes periódicos?>
                        </div>
                        <div align="center">
                        	<input class="boton-style" type="submit" name="enviarPeriodicidad" value="Enviar">
                       	</div>
					</form>
				</fieldset>
         	</div> 
            <br/>
        </section>
        <?php
			mysql_free_result($resultado_estado_periodicidad_diaria); //liberamos memoria
			mysql_free_result($resultado_estado_periodicidad_mensual);
			mysql_free_result($resultado_estado_periodicidad_anual); 
			mysql_close($bdconex); //nos desconectamos de la base de datos
		?>
	</section>
    
    
   	<footer>
    	<table id="pie" align="center" width="100%">
        	<tr>
            	<td id="pie_izquierda">
                	<b>Autor:</b> Javier García Prieto
            		<br/>
            		<b>Contacto:</b> <a href="mailto:javier.garcia.prieto@alumnos.uva.es" style="text-decoration:none; color:#FFF">javier.garcia.prieto@alumnos.uva.es
                </td>
                <td id="pie_derecha">
                	<b>Trabajo de Fin de Grado:</b>
            		<br/>
            		"Sistema de seguridad y monitorización basado en Raspberry Pi"
                </td>
            </tr>
            <tr>
                <td id="pie_centro" colspan="2">
               		Universidad de Valladolid
        			<br/>
        			Copyright © tfgjgp.ddns.net 2017
                </td>
            </tr>
        </table>
  	</footer> 
</body>
</html>