<?php include ("../acceso/seguridad.php");	//verifica que el usuario está correctamente identificado?>

<!DOCTYPE html>
<html lang="es">
<head>
     <meta charset="utf-8"/>
     <title>Alertas</title>
     <link rel="stylesheet" type="text/css" href="../css/style.css">
     <link rel="stylesheet" type="text/css" href="../css/menu.css">
     <link rel="icon" type="image/png" href="../img/logo_raspy.png">
</head>

<body>
	<header> 
    	<img src="../img/logo_raspy.png" width="115" height="115" class="imgCabecera" align="absmiddle">
        <span class="tituloCabecera">Sistema de seguridad y monitorización basado en Raspberry Pi</span>
    </header>
    
    
    <div id="menu">
		<ul>
  			<li class="nivel1"><a href="./inicio.php" class="nivel1">Inicio</a></li>
  			<li class="nivel1"><a href="./camara.php" class="nivel1">Cámara</a>
           	 	<ul>
                    <li><a href="./galeria.php">Galería</a></li>
				</ul>
           	</li>
  			<li class="nivel1"><a href="./informes.php" class="nivel1">Informes</a>
				<ul>
                    <li><a href="./contenedorPDF.php">Informes Guardados</a></li>
				</ul>
			</li>
  			<li class="nivel1"><a href="./alertas.php" class="nivel1">Alertas</a></li>
  			<li class="nivel1"><a href="./control.php" class="nivel1">Control</a></li>
            <li class="cerrar"><a href="./salir.php" class="nivel1">Cerrar Sesión</a></li>
		</ul>
	</div>


	<section id="seccion0">
       	<div align="center">  
      	<fieldset class="fieldsetAlertas">
			<legend style="text-align:center"> <h1 class="titulo_seccion">Formulario ALertas</h1></legend>
			<br/><br/>  
			<form id="configurarAlerta" method="post">
            	<!--en este apartado del formulario seleccionamos uno de los posibles destinatarios-->
				<label id="etiquetaFormulario" for="Destinatario">Destinatario: </label>
				<select name="destinatario">
					<option selected value="Ejemplo">Encargado de mantenimiento</option>
					<option value="BotFather">Jefe de Fábrica</option>
				</select>
                <br/><br/>

				<!--en este apartado del formulario seleccionamos uno de los posibles tipos de incidencia-->
                <label id="etiquetaFormulario" for="Codigo">Seleccione la incidencia:</label>
				<table width="814" height="409" align="center" style="text-align:center; border-spacing:10px 0px; margin-top:10px; border-top:solid 2px; border-bottom:solid 2px">
        			<tr>
                      	  <th id="letrasCelda" width="232" height="43" scope="col" style="background-color:#bb1133">Temperatura</th>
                          <th width="231" scope="col" style="background-color:#eb2d53">Humedad</th>
                          <th width="163" scope="col" style="background-color:#bb1133">Humo</th>
                          <th width="191" scope="col" style="background-color:#eb2d53">Cámara</th>
        			</tr>
        			<tr>
          				<td height="175" style="background-color:#bb1133"><label>
          					<input type="radio" name="codigo" value="01: Temperatura por encima del límite establecido."/>
           					<img src="../img/temperaturaAlta.jpg" width="227" height="148">01:Temperatura Alta
          				</label></td>
          				<td style="background-color:#eb2d53"><label>
            				<input type="radio" name="codigo" value="03: Humedad por encima del límite establecido." />
            				<img src="../img/humedadAlta.jpeg" width="227" height="148">03:Humedad Alta
                      	</label></td>
          				<td rowspan="2" style="background-color:#bb1133"><label>
          					<input type="radio" name="codigo" value="05: Se ha detectado humo."/>
            				<img src="../img/humoDetectado.jpg" width="159" height="331">05:Humo Detectado
            			</label></td>
          				<td rowspan="2" style="background-color:#eb2d53"><label>
          					<input type="radio" name="codigo" value="06: Error en la cámara."/>
            				<img src="../img/errorCamara.jpg" width="159" height="331">06:Error Cámara
                      	</label></td>
        			</tr>
        			<tr>
          				<td height="178" style="background-color:#bb1133"><label>
            				<input type="radio" name="codigo" value="02: Temperatura por debajo del límite establecido." />
            				<img src="../img/temperaturaBaja.jpg" width="227" height="148">02:Temperatura Baja 
           				</label></td>
          				<td width="231" style="background-color:#eb2d53"><label>
          					<input type="radio" name="codigo" value="04: Humedad por debajo del límite establecido."/>
            				<img src="../img/humedadBaja.jpg" width="227" height="148">04:Humedad Baja
          				</label></td>
        			</tr>
				</table>
               	<br/>

				<!--en este apartado del formulario podemos describir la incidencia-->
                <label id="etiquetaFormulario" for="descripcion">Descripción de la incidencia:</label> <br/>
				<textarea id="descripcion" name="descripcion" cols="67" rows="5"></textarea>
                <br/><br/>
  
				<!--en este apartado del formulario nos identificamos como emisores de la alerta-->
                <label id="etiquetaFormulario" for="Emisor">Emisor de la alerta: </label>
				<input type="text" name="emisor" id="emisor" size="40" maxlength="250" />
                <br/><br/>
				
              	<div align="center">
					<input class="boton-style" type="submit" name="enviarAlerta" value="Enviar Alerta"/>
                </div>
				<?php include ("../controladores/controladorEnviarAlerta.php");	//controlador que gestiona el envío de las alertas a través de Telegram?>
			</form>
		</fieldset>
        </div>
		<br>
	</section>
    

   	<footer>
    	<table id="pie" align="center" width="100%">
        	<tr>
            	<td id="pie_izquierda">
                	<b>Autor:</b> Javier García Prieto
            		<br/>
            		<b>Contacto:</b> <a href="mailto:javier.garcia.prieto@alumnos.uva.es" style="text-decoration:none; color:#FFF">javier.garcia.prieto@alumnos.uva.es
                </td>
                <td id="pie_derecha">
                	<b>Trabajo de Fin de Grado:</b>
            		<br/>
            		"Sistema de seguridad y monitorización basado en Raspberry Pi"
                </td>
            </tr>
            <tr>
                <td id="pie_centro" colspan="2">
               		Universidad de Valladolid
        			<br/>
        			Copyright © tfgjgp.ddns.net 2017
                </td>
            </tr>
        </table>
  	</footer> 
</body>
</html>