<?php include ("../acceso/seguridad.php");	//verifica que el usuario está correctamente identificado?>  

<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="utf-8"/>
   	<title>Control</title>
    <link rel="stylesheet" type="text/css" href="../css/style.css">
    <link rel="stylesheet" type="text/css" href="../css/menu.css">
    <link rel="icon" type="image/png" href="../img/logo_raspy.png">
    
	<?php
		include ("../controladores/controladorEncendidoApagadoAlarma.php");		//se incluye el controlador de la alarma
		include ("../controladores/controladorEncendidoApagadoRegulador.php");	//se incluye el controlador del regulador de temperatura
	?>
</head>

<body>
	<header> 
    	<img src="../img/logo_raspy.png" width="115" height="115" class="imgCabecera" align="absmiddle">
        <span class="tituloCabecera">Sistema de seguridad y monitorización basado en Raspberry Pi</span>
    </header>
    
    
    <div id="menu">
		<ul>
  			<li class="nivel1"><a href="./inicio.php" class="nivel1">Inicio</a></li>
  			<li class="nivel1"><a href="./camara.php" class="nivel1">Cámara</a>
           	 	<ul>
                    <li><a href="./galeria.php">Galería</a></li>
				</ul>
           	</li>
  			<li class="nivel1"><a href="./informes.php" class="nivel1">Informes</a>
				<ul>
                    <li><a href="./contenedorPDF.php">Informes Guardados</a></li>
				</ul>
			</li>
  			<li class="nivel1"><a href="./alertas.php" class="nivel1">Alertas</a></li>
  			<li class="nivel1"><a href="./control.php" class="nivel1">Control</a></li>
            <li class="cerrar"><a href="./salir.php" class="nivel1">Cerrar Sesión</a></li>
		</ul>
	</div>
   
   
   	<section id="seccion0">
    	<h1 class="titulo_seccion">Control manual de actuadores</h1>
  		<br/>

        <form method="post">
         	<table style="width: 75%; text-align: left; margin-left: auto; margin-right: auto;"
         	border="0" cellpadding="2" cellspacing="2">
            	<tbody>
         			<tr>
            			<td style="text-align: center;"><button class="boton-style" name="alarmaON">Alarma ON</button></td>
            			<td style="text-align: center;"><button class="boton-style" name="alarmaOFF">Alarma OFF</button></td>
          			</tr>
         			<tr>
            			<td style="text-align: center;"><button class="boton-style" name="reguladorON">Regulador ON</button></td>
            			<td style="text-align: center;"><button class="boton-style" name="reguladorOFF">Regulador OFF</button></td>
          			</tr>
        	</tbody>
          </table>
        </form>
	</section>
    
    
   	<footer>
    	<table id="pie" align="center" width="100%">
        	<tr>
            	<td id="pie_izquierda">
                	<b>Autor:</b> Javier García Prieto
            		<br/>
            		<b>Contacto:</b> <a href="mailto:javier.garcia.prieto@alumnos.uva.es" style="text-decoration:none; color:#FFF">javier.garcia.prieto@alumnos.uva.es
                </td>
                <td id="pie_derecha">
                	<b>Trabajo de Fin de Grado:</b>
            		<br/>
            		"Sistema de seguridad y monitorización basado en Raspberry Pi"
                </td>
            </tr>
            <tr>
                <td id="pie_centro" colspan="2">
               		Universidad de Valladolid
        			<br/>
        			Copyright © tfgjgp.ddns.net 2017
                </td>
            </tr>
        </table>
  	</footer> 
</body>
</html>